/*
 * network.java
 *
 * Created on 2005-7-25, 2:54
 *
 */
package sdisk;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.reflect.*;

/**
 *
 * @author Edward
 */
public class network {

    public NetworkInterface ni;
    public Inet4Address iaddr;
    public DatagramSocket ds;
    public DatagramPacket packet, packetr;
    private byte[] buf, bufr;

    /* Create a new instance of network */
    public network() {
        int PPPoE_flag = 0;
        buf = new byte[72];
        bufr = new byte[72];
        packet = new DatagramPacket(buf, 72);
        packetr = new DatagramPacket(bufr, 72);

        /* Get active interface */
        try {
            Enumeration interfaces;
            NetworkInterface ni_temp;
            interfaces = NetworkInterface.getNetworkInterfaces();
            while (interfaces.hasMoreElements()) {
                ni_temp = (NetworkInterface) interfaces.nextElement();

                if (ni_temp.isLoopback() == true) {
                    continue;
                }

                if (ni_temp.isUp() == false) {
                    continue;
                }

                if (ni_temp.isPointToPoint() == true) {
                    PPPoE_flag = 1; // Has PPPoE link
                    continue;
                }

                ni = ni_temp;
                System.out.println(ni);
            }
        } catch (Exception ex) {
            System.out.println(ex);
        }

        /* Get ip address of active interface */
        try {
            Enumeration inetaddrs;
            InetAddress iaddr_temp;
            inetaddrs = ni.getInetAddresses();
            while (inetaddrs.hasMoreElements()) {
                iaddr_temp = (InetAddress) inetaddrs.nextElement();
                if (iaddr_temp instanceof Inet6Address) {
                    continue;
                }

                iaddr = (Inet4Address) iaddr_temp;
                break;
            }

        } catch (Exception ex) {
            System.out.println(ex);
        }

        try {
            if (PPPoE_flag != 0) {
                ds = new DatagramSocket(14675, iaddr); // Create Datagram Socket and bind to a specific local address
            } else {
                ds = new DatagramSocket(14675); // Create Datagram Socket and specify local host port number
            }

            ds.setBroadcast(true);

            /* Set destination ip broadcast */
            packet.setAddress(InetAddress.getByName("255.255.255.255"));
            packet.setPort(14675); // Set destination port
        } catch (Exception ex) {
            System.out.println(ex);
        }
    }

    public boolean request() {
        short i;

        /* Initial send buf */
        for (i = 0; i < Array.getLength(buf); i++) {
            buf[i] = 0;
            bufr[i] = 0;
        }

        buf[0] = 0x0001; // Ver 1
        buf[2] = 0x0000; // Request

        try {
            /* Send packet */
            ds.setSoTimeout(333);
            ds.send(packet);
        } catch (IOException ex) {
            System.out.println(ex);
            return false;
        }

        return true;
    }

    public boolean getresponse() {
        try {
            /* Receive once, 0.333s timeout */
            ds.setSoTimeout(333);
            while (true) {
                ds.receive(packetr);

                if ((short) bufr[0] == 0x0001 && (short) bufr[2] == 0x0000) {   // Ver 1 && Request packet
                    continue;
                }

                return true;
            }
        } catch (IOException ex) {  // Timeout
            System.out.println(ex);
            return false;
        }
    }

    public boolean setIP_request(String ip, String name, String group) {
        byte[] temp;
        short a, b, c, d, i;

        StringTokenizer st = new StringTokenizer(ip, ".");

        /* Initial send buf */
        for (i = 0; i < Array.getLength(buf); i++) {
            buf[i] = 0;
            bufr[i] = 0;
        }

        buf[0] = 0x01;
        buf[2] = 0x02;

        /* buf[4] to buf[7] is IP */
        a = Short.parseShort(st.nextToken());
        buf[4] = (byte) a;
        b = Short.parseShort(st.nextToken());
        buf[5] = (byte) b;
        c = Short.parseShort(st.nextToken());
        buf[6] = (byte) c;
        d = Short.parseShort(st.nextToken());
        buf[7] = (byte) d;

        /* Get Host Name */
        temp = name.getBytes();
        for (i = 0; i < Array.getLength(temp); i++) {
            buf[8 + i] = temp[i];
        }

        /* Get Group Name */
        temp = group.getBytes();
        for (i = 0; i < Array.getLength(temp); i++) {
            buf[24 + i] = temp[i];
        }

        try {
            /* Send packet */
            ds.setSoTimeout(333);
            ds.send(packet);
        } catch (IOException ex) {
            System.out.println(ex);
            return false;
        }

        return true;
    }

    /* Get receive buffer */
    public byte[] getBuf() {
        return bufr;
    }
}